//LibreOfficeDrawSVGtoAiSVG
//
// LibreOffice Drawを使ってレーザー加工機の切断パスを作成する時に
//LibreOffice Drawで保存したSVGファイルをAdobeIllustratorのSVGファイル風に変換するアプリケーション
//
//計測・解析ラボ　大橋康司　2021.07.22
//無保証
//CC BY-NC


String svgFile;
String newFileName;
String fileExtension=".svg";
String insertSuffix="_ai.svg";

BufferedReader reader;
String line;
PrintWriter writer;

String headerKey="xml:space="+ char(34)+"preserve"+char(34)+">";//  xml:space="preserve">
String pathKey="<path fill="+ char(34)+"none"+ char(34);//                    <path fill="none"
 
void setup() {
  size(560,180);
  titleText();
  selectInput("変換するSVGファイルを選択してください。", "newThread");
}

void convertSVG(){
  reader = createReader(svgFile);//      file path to "User selected SVG file"
  newFileName=svgFile.replace(fileExtension,insertSuffix);
  writer = createWriter(newFileName);
  while(true){
    try {
      line = reader.readLine();
    } catch (IOException e) {
      e.printStackTrace();
      line = null;
    }
    if (line != null) {
      if (line.contains(headerKey)){
        writer.println(line);
      }
      if (line.contains(pathKey)){
        writer.println(line);
      }
      
    } else {
      writer.println("</svg>");
      writer.flush();
      writer.close();
      exit();
    }
  }
}


void newThread(File selection) {
  if (selection == null) {
    println("Window was closed or the user hit cancel.");
  } else {
    svgFile=selection.getAbsolutePath();
    if(svgFile.contains(fileExtension)){
      println(svgFile);
      println("SVG file Selected");
      convertSVG();
    } else{
      println("Select SVG file");
      exit();
    }
  }
}

  void titleText(){
    background(190,220,240);
    textSize(40);
    fill(0,0,255);
    text("Convert LibreOffice SVG", 50, 50);
    text("to AI style SVG", 230, 100);
    fill(255,0,0);
    text("Select SVG File", 50, 150);
    delay(3000);
  }